#include<intrins.h>
#define uchar unsigned char
#define uint  unsigned int
//Header file for EEPROM AT24C02 finctions
sbit	Scl=P2^7;	//Serial Clock
sbit	Sda=P2^6;	//Serial Data
/*Send start condition*/
void Start(void)        /*Initial conditions*/
{
        Sda=1;
        Scl=1;
        _nop_ ();
        _nop_ ();
        _nop_ ();
        _nop_ ();
        Sda=0;
        _nop_ ();
        _nop_ ();
        _nop_ ();
        _nop_ ();
}
void Stop(void) /*Stop condition*/
{
        Sda=0;
        Scl=1;
        _nop_ ();
        _nop_ ();
        _nop_ ();
        _nop_ ();
        Sda=1;
        _nop_ ();
        _nop_ ();
        _nop_ ();
        _nop_ ();
}
void Ack(void)  /*Acknowledge bit*/
{
        Sda=0;
        _nop_ ();
        _nop_ ();
        _nop_ ();
        _nop_ ();
        Scl=1;
        _nop_ ();
        _nop_ ();
        _nop_ ();
        _nop_ ();
        Scl=0;
}
void  NoAck(void)       /*Reverse acknowledge bit*/
{
        Sda=1;
        _nop_ ();
        _nop_ ();
        _nop_ ();
        _nop_ ();
        Scl=1;
        _nop_ ();
        _nop_ ();
        _nop_ ();
        _nop_ ();
        Scl=0;
}
void Send(uchar Data)   /*Subroutine to send data,Data is required to send data*/
{
        uchar BitCounter=8;       /*Median control*/
        uchar temp;     /*Intermediate variable control*/
        do
        {
           temp=Data;
           Scl=0;
           _nop_ ();
           _nop_ ();
           _nop_ ();
           _nop_ ();
           if((temp&0x80)==0x80)/* If the highest bit is 1*/
                Sda=1;
           else
                Sda=0;
           Scl=1;
           temp=Data<<1;        /*RLC*/
           Data=temp;
           BitCounter--;
         }while(BitCounter);
         Scl=0;
}
uchar Read(void) /*Read one byte of data, and returns the byte value*/
{
        uchar temp=0;
        uchar temp1=0;
        uchar BitCounter=8;
        Sda=1;
        do{
          Scl=0;
          _nop_ ();
          _nop_ ();
          _nop_ ();
          _nop_ ();
          Scl=1;
          _nop_ ();
          _nop_ ();
          _nop_ ();
          _nop_ ();
          if(Sda)       /*If Sda=1;*/
                temp=temp|0x01;  /*The lowest temp 1*/
          else
                temp=temp&0xfe;  /*Otherwise, the lowest temp clear 0*/
          if(BitCounter-1)
          {   temp1=temp<<1;
              temp=temp1;
          }
          BitCounter--;
        }while(BitCounter);
        return(temp);
}

void WrToROM(uchar *s,uchar Address)//Write a set of data to the AT24C02 in
{     //The first parameter is an array address, data in the AT24C02 in the beginning of the address, number of data
     Start();        
     Send(0xa0);    //A0, A1, A2 earth, solid AT24C02 write address 0XA0
     Ack();
     Send(Address);  
     Ack();
     while(*s)
     {
        Send(*s++);
        Ack();
     }
     Stop();
}
void  RdFromROM(uchar Data[],uchar Address,uchar Num)//Read out in a set of data to the AT24C02
     //The first parameter is an array address, data in the AT24C02 in the beginning of the address, number of data
{
     uchar i=0;
     uchar *PData;
     PData=Data;
     for(i=0;i<Num;i++)
     {
        Start();
        Send(0xa0); //A0, A1, A2 earth, solid AT24C02 write address 0XA0
        Ack();
        Send(Address+i);
        Ack();
        Start();
        Send(0xa1); //A0, A1, A2 earth, solid AT24C02 read address 0XA1
        Ack();
        *(PData+i)=Read();
        Scl=0;
        NoAck();
        Stop();
   }
}