#include <reg51.h>  		
#include "lcd4bit.h"
#include "ds1307.h"		
	
code const unsigned char * MonthStr[12]={{"Jan"},
										{"Feb"},
										{"Mar"},
										{"Apr"},
										{"May"},
										{"Jun"},
										{"Jul"},
										{"Aug"},
										{"Sep"},
										{"Oct"},
										{"Nov"},
										{"Dec"}};
code const unsigned char * DayStr[7]  ={{"Sun"},
				   						{"Mon"},
				   						{"Tue"},
				   						{"Wen"},
				   						{"Thu"},
				   						{"Fri"},
				   						{"Sat"}};
//code const char cust[8] = {0x04,0x0a,0x11,0x0a,0x04,0x04,0x04,0x00};
code const char cust[8] = {0,4,14,14,14,31,4,0};

sbit UP=P3^5;
sbit DOWN=P3^6;
sbit SET=P3^4;
sbit TT=P3^7;
unsigned char A_HR,A_MIN;
bit SET_TIME=0;
bit CURRENT_TT=0;//0 for 24 hr time format
/* Functions Declarations*/
void Chk_RTC(void);
void SetTime(void);
void ChangeTimeType(void);
void DisplayHour(unsigned char);
unsigned char BCD2HEX(unsigned char);
unsigned char Set12Hour(unsigned char);
void SetAlarm(void);
void Chk_Alarm(unsigned char,unsigned char );
void Delay(int i)
{
  unsigned int j;
  while(i-->0)
  	for(j=0;j<1000;j++);
}

char * Int2Month(unsigned char month)
{
  return MonthStr[(month)-1];
}

char * Int2Day(unsigned char day)
{
	return DayStr[day-1];
}

void send2lcd(unsigned char value)
{
	unsigned char buf = 0;	
	
	buf = value & 0xF0;		/* Filter for high byte */
	buf = (buf>>4)|(0x30);		/* Convert  to ascii code */

	WriteCharLCD(buf);			/* Show on LCD */

	buf = value & 0x0F;		/* Filter for low byte */
	buf = buf | 0x30;       	/* Convert to ascii code */

	WriteCharLCD(buf);			/* Show on LCD */
}
	
unsigned char INT2BCD(unsigned char x)
{
	unsigned char temp=0;
	temp=x%10;
	x/=10;
	temp=(x<<4)|temp;
	return temp;		
	
}
/***************************** Main function *************************************/
void dispDate(void)			
{
	unsigned char ss,mm,hh,dy,dd,mh,yy,count=0,count_min=0;
	InitLCD();
	DS1307_inti(0,0,1);
	ClearScreenLCD(1);
	GoToLCD(1,1,1);
	DisplayStrLCD(1,"Digital Clock");
	//DisplayGoTo(2,1);
	//CustomCharDisplay(cust);
	DelayMS(100);	
	ClearScreenLCD(1); 
	Chk_RTC();	
	GoToLCD(1,2,1);
	DisplayStrLCD(1,"Time:");	
	while(1) 
	{
		if(SET==0)
		{
				SetTime();
		}
		if(TT==0)
		{
				ChangeTimeType( );
		}
		/* Get Date & Time */
		ss = DS1307_get(SEC);	
		if(count==0)
		{
			mm = DS1307_get(MIN);
			if(count_min==0)
			{
				SHOW:
				
				hh = DS1307_get(HOUR);
				dy = DS1307_get(DAY);
				dd = DS1307_get(DATE);
				mh = DS1307_get(MONTH);
				yy = DS1307_get(YEAR);

				DisplayGoTo(1,1,1);
				DisplayStrLCD(Int2Day(BCD2HEX(dy)));
				WriteCharLCD(',');
				DisplayGoTo(1,5);	/* Set LCD cursor at (1,6) */
		
				send2lcd(dd);		/* Show date on LCD */
		
				WriteCharLCD('-');		
		
				DisplayStrLCD(Int2Month(BCD2HEX(mh)));	/* Show month on LCD */
		
				WriteCharLCD('-');	
				DisplayStrLCD("20");
				send2lcd(yy);		/* Show year on LCD */

				/* Show Time in format hr:min: */	
				DisplayGoTo(2,6);	/* Set LCD cursor at (2,6) */
		
				//send2lcd(hh);		/* Show hour on LCD */
				DisplayHour(BCD2HEX(hh));
				WriteCharLCD(':');       
		   		SET_TIME=0;	
				//send2lcd(mm);		/* Show min on LCD */
		
				//WriteCharLCD(':');		
			}
			DisplayGoTo(2,9);
			send2lcd(mm);
			WriteCharLCD(':');		
			count_min=BCD2HEX(mm);
			Chk_Alarm(BCD2HEX(hh),count_min);		/* Show min on LCD */
		}
		DisplayGoTo(2,12);
		send2lcd(ss);		/* Show sec on LCD */
		count=BCD2HEX(ss);
		Delay(10);
		//CustomCharDisplay(cust);
		WriteCmdLCD(0x0c);
		if(SET_TIME)
			goto SHOW;
		
	}//End of While loop	   
} /* End main */

unsigned char BCD2HEX(unsigned char bcd)
{
	
	return( ((bcd >> 4)*10) + (bcd & 0x0f) );

	
}

void SetTime(void)
{
 	unsigned char min,hr,day,dat,mon,yr,set;
	ClearScreenLCD();
	DelayMs(50);
	DisplayGoTo(1,1);
	DisplayStrLCD("Enter Minutes:");
	DisplayGoTo(2,1);
	set=BCD2HEX(DS1307_get(MIN));//set minutes
	while(SET==1)
	{
		DisplayGoTo(2,9);
		if(set<10)
		{
			WriteCharLCD('0');	
		}
		if(set>59 || set<0)
		{
			set=0;
		}
		DisplayIntegerLCD(set);
		if(UP==0)
		{	if(set==59)
				set=0;
			else
				set++;
			DelayMs(100);
		}
		if(DOWN==0)
		{
			
			if(set==0)
				set=59;
			else
				set--;
			DelayMs(100);
		}
		
		if(SET==0)
		{
			break;
		}
	}
	min=INT2BCD(set);
	//set hours
	DisplayGoTo(1,1);
	SET=UP=DOWN=1;
	ClearScreenLCD();
	DelayMs(50);
	DisplayStrLCD("Enter Hours:");
	set=BCD2HEX(DS1307_get(HOUR));
	if(CURRENT_TT==0)
	{
		DisplayGoTo(2,1);
		while(SET==1)
		{
			DisplayGoTo(2,1);
			if(set<10)
			{
				WriteCharLCD('0');	
				
			}
			if(set>23 || set<0)
			{
				set=0;
			}
			DisplayIntegerLCD(set);
			if(UP==0)
			{	
				if(set==23)
					set=0;	
				else
					set++;
				DelayMs(100);
			}
			if(DOWN==0)
			{
				if(set==0)
					set=23;
				else
					set--;
				DelayMs(100);
			}
		}
		hr=INT2BCD(set);
	}
	else
	{
	 	hr=INT2BCD(Set12Hour(set));
	}
	ClearScreenLCD();
	DelayMs(200);
	DisplayGoTo(1,1);
	DisplayStrLCD("Enter Day:");
	set=BCD2HEX(DS1307_get(DAY));
	while(SET==1)
	{
		DisplayGoTo(2,1);
		if(set>7 || set<1)
		{
			set=1;
		}
		DisplayStrLCD(Int2Day(set));
		if(UP==0)
		{
			set++;
			DelayMs(100);
		}
		if(DOWN==0)
		{
			
			if(set==1)
				set=7;
			else
				set--;
			
			DelayMs(100);
		}
	}
	day = INT2BCD(set);
	ClearScreenLCD();
	//set date
	DelayMs(200);

	DisplayGoTo(1,1);
	DisplayStrLCD("Enter Date:");
	set=BCD2HEX(DS1307_get(DATE));
	while(SET==1)
	{
		DisplayGoTo(2,1);
		if(set<10)
		{
			WriteCharLCD('0');	
			
		}
		if(set>31 || set<0)
		{
			set=1;
		}
		DisplayIntegerLCD(set);
		if(UP==0)
		{
			set++;
			DelayMs(100);
		}
		if(DOWN==0)
		{
			
			if(set==0)
				set=31;
			else
				set--;
			DelayMs(100);
		}
		
		
	}
	dat= INT2BCD(set);
	ClearScreenLCD();
	DelayMs(200);
	DisplayGoTo(1,1);
	DisplayStrLCD("Enter Month:");
	set=BCD2HEX(DS1307_get(MONTH));
	while(SET==1)
	{
		DisplayGoTo(2,1);
		if(set>12 || set<=0)
		{
			set=1;
		}
		if(set==0)
				set=12;
		DisplayStrLCD(Int2Month(set));
		if(UP==0)
		{
			set++;
			DelayMs(100);
		}
		if(DOWN==0)
		{
			
			if(set==1)
				set=12;
			else
				set--;
			DelayMs(100);
		}
		
		
	}
	mon = INT2BCD(set);
	ClearScreenLCD();
	DelayMs(200);
	DisplayGoTo(1,1);
	DisplayStrLCD("Enter year:");
	DisplayGoTo(2,1);
	DisplayStrLCD("20");
	set=BCD2HEX(DS1307_get(YEAR));
	while(SET==1)
	{
		DisplayGoTo(2,3);
		if(set>99 || set<10)
		{
			set=10;
		}
		DisplayIntegerLCD(set);
		if(UP==0)
		{
			set++;
			DelayMs(100);
		}
		if(DOWN==0)
		{
			
			if(set==0)
				set=99;
			else
				set--;
			DelayMs(100);
		}
	}
	yr=INT2BCD(set);
	ClearScreenLCD();
	DelayMs(50);
	DisplayGoTo(2,1);
	DisplayStrLCD("Time:");	
   	DS1307_settime(day,hr,min,0x00);
	DS1307_setdate(dat,mon,yr);
	SET_TIME=1;
}
void Chk_RTC(void)
{
 	unsigned char ss,mm,hh,dy;	
	bit status=0;
	ClearScreenLCD();
	//DisplayGoTo(1,1);
	DisplayStrLCD("Checking...");
	DelayMs(200);
	ClearScreenLCD();
	ss = DS1307_get(SEC);
	ss=BCD2HEX(ss);
	if(ss>59 || ss<0)
	{
	 	status=1;
	}
	mm = BCD2HEX(DS1307_get(MIN));	
	if(mm>59 || mm<0)
	{
	 	status|=1; 
	}
	hh = BCD2HEX(DS1307_get(HOUR));
	if(hh>23 ||hh<0)
	{			  
	 	status|=1; 
	}
	dy = DS1307_get(DAY);
	if(dy==0xff)
	{
	 	status|=1; 
	}
	if(status)
	{
	  	DS1307_settime(0x01,0x00,0x00,0x00);
		DS1307_setdate(0x16,0x05,0x10);
		DisplayStrLCD("Please set time");
		DisplayGoTo(2,1);
		DisplayStrLCD("and date.");
		DelayMs(200);
	}
	else
	{
		DisplayGoTo(1,1);
		DisplayStrLCD("OK...");
		DelayMs(200);
	}
}
void ChangeTimeType( )
{
	
	ClearScreenLCD();
	DelayMs(300);
	if(SET==0)
	{
		SetAlarm();
	}
	CURRENT_TT=	~CURRENT_TT;
	DelayMs(25);
	SET_TIME=1;
}
void DisplayHour(unsigned char hr)
{
	DisplayGoTo(2,1);
	DisplayStrLCD("Time:");
	if(CURRENT_TT==1)//12 hr mode
	{
		DisplayGoTo(2,14);
		if((hr >= 12) && (hr <= 23))
		{
			hr-=12;
			DisplayStrLCD("PM");		
		}
		else
		{
			DisplayStrLCD("AM");	
		}
		DisplayGoTo(2,6);
		if(hr==0)
		{
		 	hr=12;
		}
		if(hr<10)
		{
			WriteCharLCD('0');	
		}
		DisplayIntegerLCD(hr);
		WriteCharLCD(':');
	}
	else
	{
			
		DisplayGoTo(2,6);
		if(hr<10)
		{
			WriteCharLCD('0');	
		}
		DisplayIntegerLCD(hr);
	}
}
unsigned char Set12Hour(unsigned char set)
{
	int min;bit tt=0;
	min=BCD2HEX(DS1307_get(MIN));   ;
	if(set>12 && set<=23)
	{
		set-=12;
		tt=1;
		DisplayGoTo(2,14);
		DisplayStrLCD("PM");		
	}
	else
	{
		tt=0;
		DisplayGoTo(2,14);
		DisplayStrLCD("AM");	
	}
	while(SET==1)
	{
		if(tt)
		{
			DisplayGoTo(2,14);
			DisplayStrLCD("PM");		
		}
		else
		{
			DisplayGoTo(2,14);
			DisplayStrLCD("AM");	
		}
	
		if(set==0)
		{
		 	set=12;tt=0;
		}
		DisplayGoTo(2,1);
		if(set<10)
		{
			WriteCharLCD('0');	
			
		}
		if(set>12 || set<0)
		{
			set=1;
		}
		DisplayIntegerLCD(set);
		if(UP==0)
		{	
			if(set==12)
			{	
				set=1;
				tt=~tt;
			}	
			else
				set++;
			DelayMs(100);
		}
		if(DOWN==0)
		{
			if(set==1)
			{
				set=12;
				tt=~tt;
			}
			else
				set--;
			DelayMs(100);
		}
	}
	if(tt)
	{	if(set!=12)
		{
			set+=12;
		}
	}
	if(!tt)
	{
		if(set==12)
			set=0;
	}
	return set;
}	
void SetAlarm(void)
{
   	unsigned char set;
	DisplayStrLCD("Set Alarm hours:");
	DelayMs(200);
	set=BCD2HEX(DS1307_get(HOUR));
	if(CURRENT_TT==0)
	{
		DisplayGoTo(2,1);
		while(SET==1)
		{
			DisplayGoTo(2,1);
			if(set<10)
			{
				WriteCharLCD('0');	
				
			}
			if(set>23 || set<0)
			{
				set=0;
			}
			DisplayIntegerLCD(set);
			if(UP==0)
			{	
				if(set==23)
					set=0;	
				else
					set++;
				DelayMs(100);
			}
			if(DOWN==0)
			{
				if(set==0)
					set=23;
				else
					set--;
				DelayMs(100);
			}
		}
		A_HR=set;
	}
	else
	{
	 	A_HR=Set12Hour(set);
	}
	DelayMs(200);
	DisplayGoTo(1,1);
	DisplayStrLCD("Set Alarm Mins:");
	set=BCD2HEX(DS1307_get(MIN));//set minutes
	DisplayGoTo(2,3);
	WriteCharLCD(':');
	while(SET==1)
	{
		DisplayGoTo(2,4);
		if(set<10)
		{
			WriteCharLCD('0');	
		}
		if(set>59 || set<0)
		{
			set=0;
		}
		DisplayIntegerLCD(set);
		if(UP==0)
		{	if(set==59)
				set=0;
			else
				set++;
			DelayMs(100);
		}
		if(DOWN==0)
		{
			
			if(set==0)
				set=59;
			else
				set--;
			DelayMs(100);
		}
		
		if(SET==0)
		{
			break;
		}
	}
	A_MIN=set;

	CURRENT_TT=	~CURRENT_TT;
	ClearScreenLCD();
	DisplayStrLCD("Set Successfully");
	DelayMs(200);
	ClearScreenLCD();
}
void Chk_Alarm(unsigned char hr ,unsigned char min)
{
	if(min==A_MIN)
	{
	 	if(hr==A_HR)
		{
			CustomCharDisplay(cust);
			DS1307_inti(1,1,0);	
		}
	}
	else
	{
	 	DS1307_inti(0,0,0);	
		DisplayGoTo(2,16);
		WriteCharLCD(' ');
	}
}