#include<reg51.h>

#define LCD P1
#define LCDS P0
sbit RS=P1^0;
sbit RW=P1^1;
sbit EN=P1^2;

sbit RSS=P0^0;
sbit RWS=P0^1;
sbit ENS=P0^2;

void InitLCD(void);
void WriteCmdLCD(unsigned char);
void WriteCharLCD(unsigned char);

void InitLCD1(void);
void WriteCmdLCD1(unsigned char);
void WriteCharLCD1(unsigned char);

void DisplayStrLCD(unsigned char,unsigned char *);
void DisplayIntegerLCD(unsigned char,int);
void GoToLCD(unsigned char,unsigned char,unsigned char);
void ClearScreenLCD(unsigned char);

void DelayMS(int);

void InitLCD(void)
{
	LCD = 0xFF;
    DelayMS(20);
    LCD = 0x3C;		//Data = 30H, EN = 1, First Init
    LCD = 0x30;		//Data = 30H, EN = 0
    DelayMS(10);
    LCD = 0x3c;		//Second Init, Data = 30H, EN = 1
    LCD = 0x30;		//Data = 30H, EN = 0
    DelayMS(1);
    LCD = 0x3c;		//Third Init
    LCD = 0x30;
    DelayMS(1);
    LCD = 0x2c;		//Select Data width (20H for 4bit)  en=1
    LCD = 0x20;		//Data = 20H, EN = 0
    DelayMS(1);
	
	WriteCmdLCD(0x28);
	WriteCmdLCD(0x0e);
	WriteCmdLCD(0x01);
	WriteCmdLCD(0x06);
	WriteCmdLCD(0x80);
}

void WriteCmdLCD(unsigned char c)
{
	LCD=((c & 0xf0) | 0x04);
	EN=0;

    LCD=(((c & 0x0f)<<4)|0x04);
//  LCD=(((c<<4) & 0xf0)|0x04);
	//LCD=((c<<4)|0x04);
	EN=0;
	DelayMS(2);
}

void WriteCharLCD(unsigned char c)
{
	LCD=((c&0xf0)|0x05);
    EN=0;
   
	LCD=(((c & 0x0f)<<4)|0x05);
//  LCD=(((c<<4)&0xf0)|0x05);
// 	LCD=((c<<4)|0x05);
    EN=0;
	DelayMS(2);

}
void InitLCD1(void)
{
	LCDS = 0xFF;
    DelayMS(20);
    LCDS = 0x3C;		//Data = 30H, EN = 1, First Init
    LCDS = 0x30;		//Data = 30H, EN = 0
    DelayMS(10);
    LCDS = 0x3c;		//Second Init, Data = 30H, EN = 1
    LCDS = 0x30;		//Data = 30H, EN = 0
    DelayMS(1);
    LCDS = 0x3c;		//Third Init
    LCDS = 0x30;
    DelayMS(1);
    LCDS = 0x2c;		//Select Data width (20H for 4bit)  en=1
    LCDS = 0x20;		//Data = 20H, EN = 0
    DelayMS(1);
	
	WriteCmdLCD1(0x28);
	WriteCmdLCD1(0x0e);
	WriteCmdLCD1(0x01);
	WriteCmdLCD1(0x06);
	WriteCmdLCD1(0x80);
}

void WriteCmdLCD1(unsigned char c)
{
	LCDS=((c & 0xf0) | 0x04);
	ENS=0;

    LCDS=(((c & 0x0f)<<4)|0x04);
//  LCD=(((c<<4) & 0xf0)|0x04);
	//LCD=((c<<4)|0x04);
	ENS=0;
	DelayMS(2);
}

void WriteCharLCD1(unsigned char c)
{
	LCDS=((c&0xf0)|0x05);
    ENS=0;
   
	LCDS=(((c & 0x0f)<<4)|0x05);
//  LCD=(((c<<4)&0xf0)|0x05);
// 	LCD=((c<<4)|0x05);
    ENS=0;
	DelayMS(2);

}

void DisplayStrLCD(unsigned char disp,unsigned char *s)
{
	while(*s)
	{
		if(disp==0)
				WriteCharLCD(*s++);
		else
				WriteCharLCD1(*s++);				
	}

}

void DisplayIntegerLCD(unsigned char disp,int n)
{
unsigned char c[6];
unsigned int i=0;
  if(n<0)
  {
    if(disp==0)
		WriteCharLCD('-');
	else
		WriteCharLCD1('-');
    n=-n;
  }
  if(n==0)
  { 
   	if(disp==0)
   		WriteCharLCD('0');
	else
   		WriteCharLCD1('0');
  }
  while(n>0)
  {
    c[i++]=(n%10)+48;
    n/=10;
  }
  while(i-->=1)
  {
    if(disp==0)
		WriteCharLCD(c[i]);
	else
		WriteCharLCD1(c[i]);
   }
}

void GoToLCD(unsigned char disp,unsigned char row,unsigned char pos)
{
	if(row==1)
	{
		if(disp==0)
			WriteCmdLCD(0x80+pos-1);
		else
			WriteCmdLCD1(0x80+pos-1);
	}
	if(row==2)
	{
	 	if(disp==0)
			WriteCmdLCD(0xc0+pos-1);	
		else
			WriteCmdLCD1(0xc0+pos-1);	
	}
}
void ClearScreenLCD(unsigned char disp)
{
	if(disp==0)
	{
		WriteCmdLCD(0x01);
		WriteCmdLCD(0x80);		
	}
	else
	{
		WriteCmdLCD1(0x01);
		WriteCmdLCD1(0x80);		
	}
}


void DelayMS(int i)
{
  unsigned int j;
  while(i-->0)
  	for(j=0;j<106;j++);
}
