sbit M1A=P2^4;
sbit M1C=P2^5;
sbit M2A=P3^0;
sbit M2C=P3^1;
void WelcomeMSG(void)
{
	DisplayStrLCD(0,"    Welcome   ");
	GoToLCD(0,2,1);
	DelayMS(200);
	DisplayStrLCD(0,"CarParkingSystem");
	DelayMS(200);
    ClearScreenLCD(0);
	DelayMS(200);
	DisplayIntegerLCD(0,4);
	DelayMS(200);
	DisplayStrLCD(0,"Slots available");
	ClearScreenLCD(1);
	DisplayStrLCD(1,"Thank you");
}
unsigned char GetAvailableSlots(void)
{
 	unsigned char s=0;
	if(P2&0x01)
		 s++;
	if(P2&0x02)
		s++;
	if(P2&0x04)
		s++;
	if(P2&0x08)
		s++;
	return (s+48);
	
}
unsigned char GetNextSlot(void)
{
 	unsigned char s=0;
	if(P2&0x01)
	{	 
		return (49);
	}
	if(P2&0x02)
	{
		return (50);
	}
	if(P2&0x04)
	{
		return (51);
	}
	if(P2&0x08)
	{
		return (52);
	}
	return (48);
	
}
void OpenEntryGate(void)
{
	M1A=0;
	M1C=1;
}
void CloseEntryGate(void)
{
	M1A=1;
	M1C=0;
}
void PauseEntryGate(void)
{
	M1A=0;
	M1C=0;
}
void OpenExitGate(void)
{
	M2A=1;
	M2C=0;
}
void CloseExitGate(void)
{
	M2A=0;
	M2C=1;
}
void PauseExitGate(void)
{
	M2A=0;
	M2C=0;
}
unsigned int CalculateAmount(unsigned char m1,unsigned char h1,unsigned char m2, unsigned char h2)
{
	unsigned char total_min1,total_min2,rem;
	unsigned char rate;
	unsigned int cal;
	total_min1=h1*60+m1;
	total_min2=h2*60+m2;
	cal = total_min1-total_min2;
	
	RdFromROM(&rate,0x50,1);
	
	if(cal<30)
	{
		cal=(int)rate;
	}
	else
	{
		rem=cal%30;
		cal=cal/30;
		if(rem>0)
			cal++;
		cal= (cal*(int)rate);	
	}
	return cal;
}
void ClearSlotData(unsigned char slot)
{
 	unsigned char dat[4]={0,0,0,0};
	switch(slot)
	{
		case 1:
				WrToROM(dat,0x00); //@ 0x00 location the in time for slot 1 is stored
		   		DelayMS(50);
		   		WrToROM("O",0x40);
				break;
		case 2:
				WrToROM(dat,0x10); //@ 0x00 location the in time for slot 1 is stored
		   		DelayMS(50);
		   		WrToROM("O",0x41);
				break;

		case 3:
				WrToROM(dat,0x20); //@ 0x00 location the in time for slot 1 is stored
		   		DelayMS(50);
		   		WrToROM("O",0x42);
				break;

		case 4:
				WrToROM(dat,0x30); //@ 0x00 location the in time for slot 1 is stored
		   		DelayMS(50);
		   		WrToROM("O",0x43);
				break;

		default:
				break;
	
	}
}
void Billing(void)
{
 	unsigned char dat[4]={0,0,0,0},time[2]={0,0};
	unsigned char mm,hh,slot;
	unsigned int amt;
   	
	mm = DS1307_get(MIN);
	hh = DS1307_get(HOUR);
	
	ClearScreenLCD(1);
	DisplayStrLCD(1,"Out:");
	send2lcd1(hh);
	DisplayStrLCD(1,":");
	send2lcd1(mm);
	
	mm = BCD2HEX(mm);
	hh = BCD2HEX(hh);
	
	RdFromROM(dat,0x40,4);
	//DisplayStrLCD(1,dat);
	//compare wih sensor data and  stored values and find which slot has been recently vacant 
	if((dat[0]=='A')  && (P2&0x01))//here A stands for alloted
	{	 
		RdFromROM(time,0x00,2);
		amt=CalculateAmount(mm,hh,time[0],time[1]);
		slot=1;
	}
	else if((dat[1]=='A')  && (P2&0x02))
	{	 
		RdFromROM(time,0x10,2);	
		amt=CalculateAmount(mm,hh,time[0],time[1]);
		slot=2;
	}
	else if((dat[2]=='A')  && (P2&0x04))
	{	 
		RdFromROM(time,0x20,2);	
		amt=CalculateAmount(mm,hh,time[0],time[1]);
		slot=3;
	}
	else if((dat[3]=='A')  && (P2&0x08))
	{	 
		RdFromROM(time,0x30,2);	
		amt=CalculateAmount(mm,hh,time[0],time[1]);
		slot=4;
	}
	ClearSlotData(slot);
	GoToLCD(1,2,1);
	DisplayStrLCD(1,"In :");
	send2lcd1(INT2BCD(time[1]));
	DisplayStrLCD(1,":");
	send2lcd1(INT2BCD(time[0]));
	DelayMS(2000);
	ClearScreenLCD(1);
	GoToLCD(1,1,1);
	DisplayStrLCD(1,"Total:");
	DisplayIntegerLCD(1,amt);
	DisplayStrLCD(1,"Rs.");
	DelayMS(2000);
}
void DisplaySlotInfo(void)
{
 	unsigned char dat[4]={0,0,0,0},time[2]={0,0};
	ClearScreenLCD(1);
	RdFromROM(dat,(0x40),4);
	//DisplayStrLCD(1,dat);
	//compare wih sensor data and  stored values and find which slot has been recently vacant 
	//DelayMS(1000);
	if((dat[0]=='A')  && (!(P2&0x01)))//here A stands for alloted
	{	 
		GoToLCD(1,1,1);
		DisplayStrLCD(1,"1-");
		RdFromROM(time,0x00,2);
		send2lcd1(INT2BCD(time[1]));
		DisplayStrLCD(1,":");
		send2lcd1(INT2BCD(time[0]));
		DisplayStrLCD(1,"  ");
	}
	if((dat[1]=='A')  && (!(P2&0x02)))
	{	 
		RdFromROM(time,0x10,2);
		GoToLCD(1,1,9);
		DisplayStrLCD(1,"2-");
		send2lcd1(INT2BCD(time[1]));
		DisplayStrLCD(1,":");
		send2lcd1(INT2BCD(time[0]));
		DisplayStrLCD(1,"  ");	
	}
	if((dat[2]=='A')  && (!(P2&0x04)))
	{	 
		RdFromROM(time,0x20,2);
		GoToLCD(1,2,1);
		DisplayStrLCD(1,"3-");
		RdFromROM(time,0x00,2);
		send2lcd1(INT2BCD(time[1]));
		DisplayStrLCD(1,":");
		send2lcd1(INT2BCD(time[0]));
		DisplayStrLCD(1,"  ");	
	}
	if((dat[3]=='A')  && (!(P2&0x08)))
	{	 
		RdFromROM(time,0x30,2);
		GoToLCD(1,2,9);
		DisplayStrLCD(1,"4-");
		RdFromROM(time,0x00,2);
		send2lcd1(INT2BCD(time[1]));
		DisplayStrLCD(1,":");
		send2lcd1(INT2BCD(time[0]));
		DisplayStrLCD(1,"  ");	
	}
		
}				 

